diff -Naur newlib-1.20.0.orig/libgloss/epiphany/getpid.c newlib-1.20.0/libgloss/epiphany/getpid.c
--- newlib-1.20.0.orig/libgloss/epiphany/getpid.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/getpid.c	2012-03-28 10:11:12.213137968 +0200
@@ -0,0 +1,47 @@
+/* EPIPHANY implementation of _getpid ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+#include <sys/types.h>
+
+/* ------------------------------------------------------------------------- */
+/*!Get the process ID
+
+   A minimal implementation is best advised to return 1, the number of the
+   only process. This means the code will work for programs which generate
+   filenames based on the PID.
+
+   @return  the PID. This function never fails.                              */
+/* ------------------------------------------------------------------------- */
+pid_t __attribute__ ((section ("libgloss_epiphany")))
+_getpid (void)
+{
+  return  1;
+
+}	/* _getpid () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/gettimeofday.c newlib-1.20.0/libgloss/epiphany/gettimeofday.c
--- newlib-1.20.0.orig/libgloss/epiphany/gettimeofday.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/gettimeofday.c	2012-03-28 10:11:12.213137968 +0200
@@ -0,0 +1,39 @@
+/* EPIPHANY implementation of _stat ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Joern Rennecke <joern.rennecke@embecosm.com> for Adapteva Inc.
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+#include <errno.h>
+#include <sys/time.h>
+#include "syscall.h"
+
+int
+_gettimeofday (struct timeval *tp, void *tzp)
+{
+  return asm_syscall (tp, tzp, NULL, SYS_gettimeofday);
+}
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/_isatty.c newlib-1.20.0/libgloss/epiphany/_isatty.c
--- newlib-1.20.0.orig/libgloss/epiphany/_isatty.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/_isatty.c	2012-03-28 10:11:12.195137688 +0200
@@ -0,0 +1,35 @@
+/* isatty.c
+
+   Copyright (c) 1994-2009  Red Hat, Inc. All rights reserved.
+   Copyright (c) 2012 Adapteva, Inc.
+
+   This copyrighted material is made available to anyone wishing to use,
+   modify, copy, or redistribute it subject to the terms and conditions
+   of the BSD License.   This program is distributed in the hope that
+   it will be useful, but WITHOUT ANY WARRANTY expressed or implied,
+   including the implied warranties of MERCHANTABILITY or FITNESS FOR
+   A PARTICULAR PURPOSE.  A copy of this license is available at
+   http://www.opensource.org/licenses. Any Red Hat trademarks that are
+   incorporated in the source code or documentation are not subject to
+   the BSD License and may only be used or replicated with the express
+   permission of Red Hat, Inc.  */
+
+/* Dumb implementation so programs will at least run.  */
+
+#include <sys/stat.h>
+#include <errno.h>
+
+int
+_DEFUN(_isatty, (fd), int fd)
+{
+  struct stat buf;
+
+  if (_fstat (fd, &buf) < 0) {
+    errno = EBADF;
+    return 0;
+  }
+  if (S_ISCHR (buf.st_mode))
+    return 1;
+  errno = ENOTTY;
+  return 0;
+}
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/kill.c newlib-1.20.0/libgloss/epiphany/kill.c
--- newlib-1.20.0.orig/libgloss/epiphany/kill.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/kill.c	2012-03-28 10:11:12.215138000 +0200
@@ -0,0 +1,52 @@
+/* EPIPHANY implementation of _kill ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <errno.h>
+#include <sys/types.h>
+
+
+/* ------------------------------------------------------------------------- */
+/*!Send a signal
+
+   This is a minimal implementation, just call the internal rise
+
+   @param[in] pid  The process that should receive the signal
+   @param[in] sig  The signal to send
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+extern int e_raise(int signum);
+int __attribute__ ((section ("libgloss_epiphany")))
+_kill (pid_t pid, int sig)
+{
+  //errno = EINVAL;
+  return  e_raise(sig);
+}	/* _kill () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/link.c newlib-1.20.0/libgloss/epiphany/link.c
--- newlib-1.20.0.orig/libgloss/epiphany/link.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/link.c	2012-03-28 10:11:12.215138000 +0200
@@ -0,0 +1,53 @@
+/* EPIPHANY implementation of _link ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <unistd.h>
+#include <syscall.h>
+
+
+/* ------------------------------------------------------------------------- */
+/*!Establish a new name for an existing file.
+
+   Call an assembly function which will generate a system call trap. Either
+   the simulator host file system or the hardware BSP must provide the
+   functionality.
+
+   @param[in] old  The existing file name
+   @param[in] new  The new file name
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+int __attribute__ ((section ("libgloss_epiphany")))
+_link (const char *old, const char *new)
+{
+  return asm_syscall (old, new, NULL, SYS_link);
+
+}	/* _link () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/lseek.c newlib-1.20.0/libgloss/epiphany/lseek.c
--- newlib-1.20.0.orig/libgloss/epiphany/lseek.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/lseek.c	2012-03-28 10:11:12.215138000 +0200
@@ -0,0 +1,47 @@
+/* EPIPHANY implementation of _lseek ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+#include <syscall.h>
+#include <sys/types.h>
+
+/* ------------------------------------------------------------------------- */
+/*!Set a position in a file
+
+   @param[in] fildes  The file descriptor on which to seek
+   @param[in] offset  The desired offset
+   @param[in] whence  Where the offset is measured from
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+off_t __attribute__ ((section ("libgloss_epiphany")))
+_lseek (int  fildes, off_t offset, int  whence)
+{
+  return asm_syscall (fildes, offset, whence, SYS_lseek);
+}	/* _lseek () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/open.c newlib-1.20.0/libgloss/epiphany/open.c
--- newlib-1.20.0.orig/libgloss/epiphany/open.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/open.c	2012-03-28 10:11:12.216138016 +0200
@@ -0,0 +1,49 @@
+/* EPIPHANY implementation of _open ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <sys/types.h>
+#include "epiphany-syscalls.h"
+#include "syscall.h"
+
+/* ------------------------------------------------------------------------- */
+/*!Open a file
+
+   @param[in] file  The name of the file to open
+   @param[in] flags The flags definining how the file should be opened
+   @param[in] mode  The permissions to be used in the new file
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+int __attribute__ ((section ("libgloss_epiphany")))
+_open (const char *file, int flags, mode_t mode)
+{
+  return asm_open (file, flags, mode);
+}	/* _open () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/read.c newlib-1.20.0/libgloss/epiphany/read.c
--- newlib-1.20.0.orig/libgloss/epiphany/read.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/read.c	2012-03-28 10:11:12.218138046 +0200
@@ -0,0 +1,49 @@
+/* EPIPHANY implementation of _read ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+#include <sys/types.h>
+#include "epiphany-syscalls.h"
+#include "syscall.h"
+
+/* ------------------------------------------------------------------------- */
+/*!Read a file
+
+   @param[in] fildes  The descriptor of the file from which to read
+   @param[in] ptr     Buffer for the read data
+   @param[in] len     Maximum number of bytes to read
+
+   @return  Number of bytes read on success, -1 on failure with an error code
+            in errno.                                                        */
+/* ------------------------------------------------------------------------- */
+ssize_t __attribute__ ((section ("libgloss_epiphany")))
+_read (int fildes, void *ptr, size_t len)
+{
+  return asm_read (fildes, ptr, len);
+}	/* _read () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/sbrk.c newlib-1.20.0/libgloss/epiphany/sbrk.c
--- newlib-1.20.0.orig/libgloss/epiphany/sbrk.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/sbrk.c	2012-03-28 10:11:12.219138062 +0200
@@ -0,0 +1,165 @@
+/* EPIPHANY implementation of _sbrk ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+/* ------------------------------------------------------------------------- */
+/* This implementation is suitable for use with the Verilator simulation of
+   the EPIPHANY.
+
+   Commenting suitable for processing by Doxygen is provided throughout.     */
+/* ------------------------------------------------------------------------- */
+#include <sys/types.h>
+#include <errno.h>
+#include <stddef.h>
+
+/* ------------------------------------------------------------------------- */
+/*!Increase program data space
+
+   This is a minimal implementation.  Assuming the heap is growing upwards
+   from __heap_start towards __heap_end.
+   See linker file for definition.
+
+   @param[in] incr  The number of bytes to increment the stack by.
+
+   @return  A pointer to the start of the new block of memory                */
+/* ------------------------------------------------------------------------- */
+void *
+_sbrk (int  incr)
+{
+	extern char __heap_start;//set by linker
+	extern char __heap_end;//set by linker
+
+	static char *heap_end;		/* Previous end of heap or 0 if none */
+	char        *prev_heap_end;
+
+	if (0 == heap_end) {
+		heap_end = &__heap_start;			/* Initialize first time round */
+	}
+
+	prev_heap_end  = heap_end;
+	heap_end      += incr;
+	//check
+	if( heap_end < (&__heap_end)) {
+
+	} else {
+		errno = ENOMEM;
+		return (char*)-1;
+	}
+	return (void *) prev_heap_end;
+
+}	/* _sbrk () */
+
+
+
+///* sbrk support */
+//
+///* The current plan is to have one sbrk handler for all cpus.
+//   Hence use `asm' for each global variable here to avoid the cpu prefix.
+//   We can't intrude on the user's namespace (another reason to use asm).  */
+//
+//#include <sys/types.h>
+///*#include <sys/syscall.h>*/
+//#include <errno.h>
+//#include <stddef.h>
+//
+///* These variables are publicly accessible for debugging purposes.
+//   The user is also free to set sbrk_size to something different.
+//   See mem-layout.c.  */
+//
+//extern int sbrk_size asm ("sbrk_size");
+//
+//caddr_t sbrk_start asm ("sbrk_start");
+//caddr_t sbrk_loc asm ("sbrk_loc");
+//extern char  end;                    /* Defined by linker.  */
+//
+///*caddr_t _sbrk_r (struct _reent *, size_t) asm ("__sbrk_r");*/
+//
+//
+///* This symbol can be defined with the --defsym linker option.  */
+//extern char __heap_end __attribute__((weak));
+//
+//
+///* FIXME: We need a semaphore here.  */
+//
+//caddr_t
+//_sbrk_r (struct _reent *r, size_t nbytes)
+//{
+//   extern char  end;			/* Defined by linker.  */
+//   static char *heap_end;		/* Previous end of heap or 0 if none */
+//   char        *prev_heap_end;
+//   register char* stack asm("sp");
+//
+//   if (0 == heap_end)
+//     {
+//       heap_end = &end;			/* Initialize first time round */
+//     }
+//
+//   prev_heap_end  = heap_end;
+//
+//   if (stack < (prev_heap_end+nbytes)) {
+//     /* heap would overlap the current stack depth.
+//      * Future:  use sbrk() system call to make simulator grow memory beyond
+//      * the stack and allocate that
+//      */
+//     errno = ENOMEM;
+//     return (char*)-1;
+//   }
+//
+//   heap_end      += nbytes;
+//
+//   return (caddr_t) prev_heap_end;
+//
+//}	/* _sbrk () */
+
+
+//caddr_t
+//_sbrk_r (struct _reent *r, size_t nbytes)
+//{
+//  caddr_t result;
+//
+//  void *heap_end;
+//
+//  heap_end = &__heap_end;
+//  if (!heap_end)
+//    heap_end = sbrk_start + sbrk_size;
+//  if (
+//      /* Ensure we don't underflow.  */
+//      sbrk_loc + nbytes < sbrk_start
+//      /* Ensure we don't overflow.  */
+//      || sbrk_loc + nbytes > (caddr_t)heap_end)
+//    {
+//      errno = ENOMEM;
+//      return ((caddr_t) -1);
+//    }
+//
+//  if (0 == sbrk_loc)
+//    sbrk_loc = &end;                 /* Initialize first time round */
+//  result = sbrk_loc;
+//  sbrk_loc += nbytes;
+//  return result;
+//}
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/stat.c newlib-1.20.0/libgloss/epiphany/stat.c
--- newlib-1.20.0.orig/libgloss/epiphany/stat.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/stat.c	2012-03-28 10:11:12.219138062 +0200
@@ -0,0 +1,48 @@
+/* EPIPHANY implementation of _stat ()
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <sys/stat.h>
+#include <syscall.h>
+
+
+/* ------------------------------------------------------------------------- */
+/*!Status of a file (by name)
+
+   @param[in]  file  Name of the file for which status is sought
+   @param[out] st    Structure for the status information
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+int __attribute__ ((section ("libgloss_epiphany")))
+_stat (const char  *file, struct stat *st)
+{
+  return asm_syscall (file, st, NULL, SYS_stat);
+}	/* _stat () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/times.c newlib-1.20.0/libgloss/epiphany/times.c
--- newlib-1.20.0.orig/libgloss/epiphany/times.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/times.c	2012-03-28 10:11:12.219138062 +0200
@@ -0,0 +1,53 @@
+/* EPIPHANY implementation of _times ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <errno.h>
+#include <sys/times.h>
+
+
+/* ------------------------------------------------------------------------- */
+/*!Get timing information for current process
+
+   This is a minimal implementation, which always fails
+
+   @todo  Is this a permissible errno?
+
+   @param[out] buf  Buffer for timing information
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+clock_t __attribute__ ((section ("libgloss_epiphany")))
+_times (struct tms *buf)
+{
+  errno = ENOSYS;
+  return -1;
+
+}	/* _times () */
